

#include <graphics.h>
#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <math.h>



void CreatWindow();





//ࠧ   ࠭ न ⭮⥫쭮 ࠭
int winLeft, winRight, winBottom, winTop;



//ࠧ  뢮  ஢ ⥬ न
double xLeft, xRight, yBottom, yTop;
//ࠧ  뢮  ᥫ   ணࠬ 
int    nLeft, nRight, mBottom, mTop;


//室  x  ᥫ n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//室  y  ᥫ m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}


//  ࠡ  栬 䨭 ८ࠧ
//ᯮ த न
class Matrix2D
{

public:
	double x[3][3];

	Matrix2D();                               // 筠

	void rotate(double fi);                      // 
	void displa(double kx, double ky);           // 殮
	void transl(double tx, double ty );          // ࠭樨

	//६ 
	friend Matrix2D operator * (const Matrix2D&, const Matrix2D&);

};

Matrix2D::Matrix2D()
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] =  0;
	x[1][0] =  0; x[1][1] =  1; x[1][2] =  0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


void Matrix2D::rotate(double fi)
{
	double cosfi = cos(fi), sinfi = sin(fi);
	x[0][0] = cosfi; x[0][1] = -sinfi; x[0][2] = 0;
	x[1][0] = sinfi; x[1][1] =  cosfi; x[1][2] = 0;
	x[2][0] =     0; x[2][1] =      0; x[2][2] = 1;
}

void Matrix2D::displa(double kx, double ky)
{
	x[0][0] = kx; x[0][1] =  0; x[0][2] = 0;
	x[1][0] =  0; x[1][1] = ky; x[1][2] = 0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] = 1;
}

void Matrix2D::transl(double tx, double ty )
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] = tx;
	x[1][0] =  0; x[1][1] =  1; x[1][2] = ty;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


Matrix2D operator * (const Matrix2D& a, const Matrix2D& b)
{
	Matrix2D c;
	double s;
	for(int i=0; i<3; i++)
		for(int j=0; j<3; j++)
		{
			s = 0;
			for(int n=0; n<3; n++)
				s += a.x[i][n]*b.x[n][j];
			c.x[i][j] = s;
		}
	return c;
}


//  ᠭ 祪 䨣
struct Point
{
	double x;
	double y;
};


//䨭 ८ࠧ न 窨 P  
// A
Point affine( Matrix2D A,  Point P)
{
	Point Pp;
		Pp.x = A.x[0][0]*P.x + A.x[0][1]*P.y + A.x[0][2]*1;
		Pp.y = A.x[1][0]*P.x + A.x[1][1]*P.y + A.x[1][2]*1;
	return Pp;
}



//न 設 ५ ⥪騥  砫
Point	PtA[7], PtA0[7];

//"६"   ࠥਨ 業 ५
	double tA , dtA, dtA0;

// 㣮   樥 殮 ५
	double fiA, kxA, kyA;

//ᮧ 6  䨭 ८ࠧ
	Matrix2D R, T, D, A, T1, T2;

//砫  ⥪騥 窨 業 ५
	double xA0, yA0, xA2, yA2, xA1, yA1;


//樠 ᪮ ⥬
void Move_OnCreate()
{


//樠 ᪮ ⥬
  int mode, res, driver = DETECT;
  initgraph(&driver, &mode,"c:\\borlandc\\bgi");
  if((res = graphresult()) != grOk)
  {
	 printf("\nGraphics error: %s\n", grapherrormsg(res));
	 exit(1);
  }


//ࠧ   ࠭ न ⭮⥫쭮 ࠭
	winLeft = int(getmaxx()*0.1); winRight = int(getmaxx()*0.9);
	winBottom = int(getmaxy()*0.85); winTop = int(getmaxy()*0.1);

//ࠧ  뢮  ஢  ࠭ न
	xLeft = -10; xRight =  10; yBottom =  -6.52; yTop =  6.52;
	nLeft = 0; nRight  = winRight-winLeft-10;
	mTop  = 0; mBottom = winBottom-winTop-24;



//	setbkcolor(15);
//ᮧ  뢮
	CreatWindow();



//砫 न 設 ५
   PtA0[0].x =  1.0; PtA0[0].y =  0.0;
   PtA0[1].x =  2.0; PtA0[1].y =  0.0;
   PtA0[2].x =  0.0; PtA0[2].y =  2.0;
   PtA0[3].x = -2.0; PtA0[3].y =  0.0;
   PtA0[4].x = -1.0; PtA0[4].y =  0.0;
   PtA0[5].x = -1.0; PtA0[5].y = -2.0;
   PtA0[6].x =  1.0; PtA0[6].y = -2.0;

// 㣮   樥 殮
	fiA = 3.14/70; kxA = 0.995; kyA = 0.995;

//蠣  ६
   dtA0 = 0.1;

}


//ࠥ ५
Point TrajA(double t)
{
	Point P;
   P.x = t - 8;
   P.y = 4 - (t - 8)*(t - 8)/10;
   return P;
}



// ५  न⠬ 設 Pt  窥 x2, y2
void Arrow( Point *Pt, int N, double x1,double y1,
	   double x2,double y2,double fi,double kx,double ky)
{

//ᮧ  䨭 ८ࠧ
		T1.transl(-x1,-y1);
		R.rotate(fi);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*T1;

//ᮢ蠥 䨭 ८ࠧ 祪 䨣
		for(int n=0; n<7; n++)
			Pt[n] = affine(A,Pt[n]);



	setlinestyle(SOLID_LINE,0,1);
	setcolor(YELLOW);


	moveto(xn(Pt[0].x),ym(Pt[0].y));
	for(int i = 0; i < N; i++)
	{
		int j = (i + 1)%N;
		lineto(xn(Pt[j].x),ym(Pt[j].y));
	}

}



void Land()
{



	setfillstyle(SOLID_FILL, GREEN);
	setlinestyle(SOLID_LINE,0,1);
	setcolor(WHITE);


	fillellipse(xn(0),ym(0),100,150);

	//㥬 न 
	setlinestyle(SOLID_LINE,0,1);
	setcolor(CYAN);


	int nb, ne, mb, me;

	nb = xn(xLeft); mb = ym(0);
	moveto(nb, mb);
	ne = xn(xRight); me = ym(0);
	lineto(ne,me);

	nb = xn(0); mb = ym(yBottom);
	moveto(nb, mb);
	ne = xn(0); me = ym(yTop);
	lineto(ne,me);

}















//ᮧ  뢮
void CreatWindow()
{
	setfillstyle(SOLID_FILL, CYAN);
	bar(winLeft, winTop, winRight, winBottom);

	setcolor(LIGHTRED);

	outtextxy(winLeft+5, winTop+7, "Korneev V");

	setcolor(WHITE);
	outtextxy(winLeft+150, winTop+7, "Move, dont remove old figure");

	setcolor(WHITE);
	rectangle(winLeft+3, winTop+17, winRight-3, winBottom-3);

//	setfillstyle(SOLID_FILL, LIGHTGRAY);
	setfillstyle(SOLID_FILL, BLACK);
	bar(winLeft+5, winTop+19, winRight-5, winBottom-5);

	setviewport(winLeft+5, winTop+19, winRight-5, winBottom-5,1);

}


//㭪 ⠭ 믮 ணࠬ  ⨨
// ,  쭥 ⨨  
//ணࠬ த 믮
//室  ணࠬ - Esc
//         㭪 StopRunQuit()   ᯮ짮  横
//    do{
//       StopRunQuit();
//    }while(1);
//
void StopRunQuit()
{
  union inkey   // ⮬ ꥤ ࠭ ଠ  ⮩ 
  {                         //ch[0] -訩  (ASCII )
	 unsigned char ch[2];    //ch[1] -訩  ( ᪠஢ )
	 int i;                  //i -ꥤ    ᫮
  } c;


		if(kbhit())
		{
			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}

			while(!kbhit());

			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}
		}
}







void main()
{


	Move_OnCreate();

	Land();


//砫  ६  ५
	tA = 0; dtA = dtA0;

//砫쭮  業 ५
	xA0 = TrajA(tA).x;
	yA0 = TrajA(tA).y;

	for(int n=0; n<7; n++)
		PtA[n] = PtA0[n];

//㥬 ५  쭮 窥
	Arrow(PtA,7,0,0,xA0,yA0,0,0.75,0.75);
	xA1 = xA0; yA1 = yA0;
	delay(2000);

	do{
		StopRunQuit();

		tA += dtA;
		xA2 = TrajA(tA).x;
		if(xA2 >= xRight-1)
		{
			xA2 = xRight-1;
			tA -= dtA;
		}
		yA2 = TrajA(tA).y;

//㥬 䨣  窥 (x2, y2)
	Arrow(PtA,7,xA1,yA1,xA2,yA2,fiA,kxA,kyA);
	xA1 = xA2; yA1 = yA2;

	delay(70);
	}while(1);



}
