

#include <graphics.h>
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <math.h>



void CreatWindow();





//ࠧ   ࠭ न ⭮⥫쭮 ࠭
int winLeft, winRight, winBottom, winTop;



//ࠧ  뢮  ஢ ⥬ न
double xLeft, xRight, yBottom, yTop;
//ࠧ  뢮  ᥫ   ணࠬ 
int    nLeft, nRight, mBottom, mTop;


//室  x  ᥫ n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//室  y  ᥫ m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}


//  ࠡ  栬 䨭 ८ࠧ
//ᯮ த न
class Matrix2D
{

public:
	double x[3][3];

	Matrix2D();                               // 筠

	void rotate(double fi);                      // 
	void displa(double kx, double ky);           // 殮
	void transl(double tx, double ty );          // ࠭樨

	//६ 
	friend Matrix2D operator * (const Matrix2D&, const Matrix2D&);

};

Matrix2D::Matrix2D()
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] =  0;
	x[1][0] =  0; x[1][1] =  1; x[1][2] =  0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


void Matrix2D::rotate(double fi)
{
	double cosfi = cos(fi), sinfi = sin(fi);
	x[0][0] = cosfi; x[0][1] = -sinfi; x[0][2] = 0;
	x[1][0] = sinfi; x[1][1] =  cosfi; x[1][2] = 0;
	x[2][0] =     0; x[2][1] =      0; x[2][2] = 1;
}

void Matrix2D::displa(double kx, double ky)
{
	x[0][0] = kx; x[0][1] =  0; x[0][2] = 0;
	x[1][0] =  0; x[1][1] = ky; x[1][2] = 0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] = 1;
}

void Matrix2D::transl(double tx, double ty )
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] = tx;
	x[1][0] =  0; x[1][1] =  1; x[1][2] = ty;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


Matrix2D operator * (const Matrix2D& a, const Matrix2D& b)
{
	Matrix2D c;
	double s;
	for(int i=0; i<3; i++)
		for(int j=0; j<3; j++)
		{
			s = 0;
			for(int n=0; n<3; n++)
				s += a.x[i][n]*b.x[n][j];
			c.x[i][j] = s;
		}
	return c;
}


//  ᠭ 祪 䨣
struct Point
{
	double x;
	double y;
};


//䨭 ८ࠧ न 窨 P  
// A
Point affine( Matrix2D A,  Point P)
{
	Point Pp;
		Pp.x = A.x[0][0]*P.x + A.x[0][1]*P.y + A.x[0][2]*1;
		Pp.y = A.x[1][0]*P.x + A.x[1][1]*P.y + A.x[1][2]*1;
	return Pp;
}






//न 祩 ᮫ ⥪騥  砫뭥
Point	PtS[8], PtS0[8];

//न 祪  ⥪騥  砫뭥
Point	PtB[11], PtB0[11];

//"६"   ࠥਨ 
	double tB , dtB0, dtB;

//"६"   ࠥਨ ᮫
	double tS , dtS0, dtS;

//"६"   ࠥਨ 
	double tC , dtC0, dtC;

//"६"   ࠥਨ 
	double tM , dtM0, dtM;

// 㣮   樥 殮
	double fi, kx, ky;

//ᮧ 6 
	Matrix2D R, T, D, A, T1, T2;

//砫쭠 窠 業 
	double xB0, yB0;

//砫쭠 窠 業 ᮫
	double xS0, yS0;

//砫쭠 窠 業 
	double xC0, yC0;

//砫쭠 窠 業 
	double xM0, yM0;


//⥪騥 窨 業 
	double xB2, yB2, xB1, yB1;

//⥪騥 窨 業 ᮫
	double xS2, yS2, xS1, yS1;

//⥪騥 窨 業 
	double xC, yC;

//⥪騥 窨 業 
	double xM, yM;

//窨 業 
	double xStar[50], yStar[50];




//㭪 ࠡ뢠 ᮮ饭  WM_CREATE
void Move_OnCreate()
{

//樠 ᪮ ⥬
//	int driver = VGA, mode = 1, errorcode;
	int mode = 1, res, driver = 9;
  initgraph(&driver, &mode,"c:\\borlandc\\bgi");
  if((res = graphresult()) != grOk)
  {
	 printf("\nGraphics error: %s\n", grapherrormsg(res));
	 exit(1);
  }


//ࠧ   ࠭ न ⭮⥫쭮 ࠭
	winLeft = int(getmaxx()*0.1); winRight = int(getmaxx()*0.9);
	winBottom = int(getmaxy()*0.85); winTop = int(getmaxy()*0.1);

//ࠧ  뢮  ஢  ࠭ न
	xLeft = -10; xRight =  10; yBottom =  -6.52; yTop =  6.52;
	nLeft = 0; nRight  = winRight-winLeft-10;
	mTop  = 0; mBottom = winBottom-winTop-24;



//न 祩 ᮫
	PtS0[0].x =  0.0; PtS0[0].y =  6.0;
	PtS0[1].x =  4.5; PtS0[1].y =  4.5;
	PtS0[2].x =  6.0; PtS0[2].y =  0.0;
	PtS0[3].x =  4.5; PtS0[3].y = -4.5;
	PtS0[4].x =  0.0; PtS0[4].y = -6.0;
	PtS0[5].x = -4.5; PtS0[5].y = -4.5;
	PtS0[6].x = -6.0; PtS0[6].y =  0.0;
	PtS0[7].x = -4.5; PtS0[7].y =  4.5;

//न 祪 
	PtB0[0].x =  0.0;  PtB0[0].y = 14.0;
	PtB0[1].x =  6.0;  PtB0[1].y =  2.0;
	PtB0[2].x =  0.0;  PtB0[2].y =  5.0;
	PtB0[3].x =  0.0;  PtB0[3].y =  3.0;
	PtB0[4].x =  3.0;  PtB0[4].y = -0.0;
	PtB0[5].x = -4.0;  PtB0[5].y =  7.0;
	PtB0[6].x =  1.0;  PtB0[6].y = -1.0;
	PtB0[7].x =  5.0;  PtB0[7].y =  1.0;
	PtB0[8].x =  4.0;  PtB0[8].y = -2.5;
	PtB0[9].x =  2.5;  PtB0[9].y = -3.5;
  PtB0[10].x = -3.0; PtB0[10].y =  4.0;


// 砩 न   
		for(int k=0; k<50; k++)
		{
			xStar[k] = xLeft+(xRight-xLeft)*(1.0*rand()/RAND_MAX);
			yStar[k] = yTop*((1.0*rand()/RAND_MAX));
		}


// 㣮   樥 殮 
	fi = 0; kx = 0.993; ky = 0.993;

//蠣  ६  
	dtB0 = 0.04;

//蠣  ६  ᮫
	dtS0 = 0.23;

//蠣  ६  
	dtC0 = 0.035;

//蠣  ६  
	dtM0 = 0.2;

}




//ࠥ 
Point TrajB(double t)
{
	Point P;
	P.x = -(t - 4.5);
	P.y = (t - 4.5);
	return P;
}



//   न⠬ 設 Pt
void Boat( Point *Pt, int N, double x1,double y1,
			  double x2,double y2,double fi,double kx,double ky)
{

//ᮧ  䨭 ८ࠧ
		T1.transl(-x1,-y1);
		R.rotate(fi);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*T1;

//ᮢ蠥 䨭 ८ࠧ 祪 䨣
		for(int n=0; n<N; n++)
			Pt[n] = affine(A,Pt[n]);

	int Poly[11];

	Poly[0] = xn(Pt[5].x); Poly[1] = ym(Pt[5].y);
	Poly[2] = xn(Pt[6].x); Poly[3] = ym(Pt[6].y);
	Poly[4] = xn(Pt[7].x); Poly[5] = ym(Pt[7].y);

  palettetype pal;
  getpalette(&pal);

	int colR = 50;
	int colG = 50;
	int colB = 50;

  setrgbpalette(pal.colors[6],colR,colG,colB);

	 colR = 43;
	 colG = 43;
	 colB = 43;

  setrgbpalette(pal.colors[7],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,1);
	setcolor(7);
	setfillstyle(1, 6);

	fillpoly(3,Poly);






	Poly[0] = xn(Pt[5].x); Poly[1] = ym(Pt[5].y);
	Poly[2] = xn(Pt[6].x); Poly[3] = ym(Pt[6].y);
	Poly[4] = xn(Pt[9].x); Poly[5] = ym(Pt[9].y);
	Poly[6] = xn(Pt[10].x); Poly[7] = ym(Pt[10].y);

	 colR = 25;
	 colG = 20;
	 colB = 20;

  setrgbpalette(pal.colors[8],colR,colG,colB);

	 colR = 25;
	 colG = 25;
	 colB = 25;

  setrgbpalette(pal.colors[9],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,1);
	setcolor(9);
	setfillstyle(1, 8);

	fillpoly(4,Poly);



	Poly[0] = xn(Pt[6].x); Poly[1] = ym(Pt[6].y);
	Poly[2] = xn(Pt[7].x); Poly[3] = ym(Pt[7].y);
	Poly[4] = xn(Pt[8].x); Poly[5] = ym(Pt[8].y);
	Poly[6] = xn(Pt[9].x); Poly[7] = ym(Pt[9].y);

	 colR = 25;
	 colG = 33;
	 colB = 25;

  setrgbpalette(pal.colors[10],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,1);
	setcolor(9);
	setfillstyle(1, 10);

	fillpoly(4,Poly);




	Poly[0] = xn(Pt[0].x); Poly[1] = ym(Pt[0].y);
	Poly[2] = xn(Pt[1].x); Poly[3] = ym(Pt[1].y);
	Poly[4] = xn(Pt[2].x); Poly[5] = ym(Pt[2].y);

	 colR = 58;
	 colG = 58;
	 colB = 58;

  setrgbpalette(pal.colors[11],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,1);
	setcolor(14);
	setfillstyle(1, 11);

	fillpoly(3,Poly);





	Poly[0] = xn(Pt[0].x); Poly[1] = ym(Pt[0].y);
	Poly[2] = xn(Pt[3].x); Poly[3] = ym(Pt[3].y);

	 colR = 63;
	 colG = 25;
	 colB = 25;

  setrgbpalette(pal.colors[12],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,1);
	setcolor(12);


	moveto(Poly[0], Poly[1]);
	lineto(Poly[2], Poly[3]);



}


//᫥  
void TracB( double te, double dt)
{
	double x, y, t;

	t = 0;
	x = TrajB(t).x;
	y = TrajB(t).y;


	setlinestyle(SOLID_LINE,0,1);
	setcolor(11);

	moveto(xn(x),ym(y));
	do{
		t += dt;
		x = TrajB(t).x;
		y = TrajB(t).y;
		lineto(xn(x),ym(y));
	}while(t < te);


}




//ࠥ ᮫
Point TrajS(double t)
{
	Point P;
	P.x = -4.5*sin(0.1*t)+4.5;
	P.y = 4.5*cos(0.1*t);
	return P;
}



// ᮫  न⠬ 設 Pt
void Sun(Point *Pt, int N, double x1,double y1,
			  double x2,double y2,double fi,double kx,double ky)
{

//ᮧ  䨭 ८ࠧ
		T1.transl(-x1,-y1);
		R.rotate(fi);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*T1;

//ᮢ蠥 䨭 ८ࠧ 祪 䨣
		for(int n=0; n<N; n++)
			Pt[n] = affine(A,Pt[n]);

	int ptx[8], pty[8];

	for(int i = 0; i < N; i++)
	{
				ptx[i] = xn(Pt[i].x); pty[i] = ym(Pt[i].y);
	}


	setlinestyle(SOLID_LINE,0,3);
	setcolor(14);
	setfillstyle(1, 14);


	for( i = 0; i < 4; i++)
	{
		moveto(ptx[i],pty[i]);
		lineto(ptx[i+4],pty[i+4]);
	}

	fillellipse((ptx[7]+ptx[3])/2,(pty[7]+pty[3])/2,abs(ptx[3]-ptx[7])/2,abs(pty[7]-pty[3])/2);


}



//㥬 ᮫ ஦
void LineSun(double x, double t)
{


	int Poly[8];

	Poly[0] = xn(x+0.2*(1+t)); Poly[1] = ym(-0.1);
	Poly[2] = xn(x-0.2*(1+t)); Poly[3] = ym(-0.1);
	Poly[4] = xn(-0.7*(1+t));  Poly[5] = ym(yBottom+0.1);
	Poly[6] = xn(0.7*(1+t));   Poly[7] = ym(yBottom+0.1);

  palettetype pal;
  getpalette(&pal);

	int colR, colG, colB;


		colR = (int)(63*exp(-0.1*t));
		colG = (int)((38*exp(-0.15*t)+ 25/(1+0.1*t)));
		colB = (int)(((1-exp(-0.2*t))*58/(1+0.1*t)));
  setrgbpalette(pal.colors[5],colR,colG,colB);


	setlinestyle(SOLID_LINE,0,3);
	setcolor(5);
	setfillstyle(1, 5);

	fillpoly(4,Poly);


}




//ࠥ 
Point TrajC(double t)
{
	Point P;
	P.x = t-7.5;
	P.y = 4.0;
	return P;
}



// 
void Cloud(double x0,double y0,double t)
{


  palettetype pal;
  getpalette(&pal);

	int colR = (int)(63*exp(-0.1*t));
	int colG = (int)(63*exp(-0.1*t));
	int colB = (int)(63*exp(-0.1*t));

  setrgbpalette(pal.colors[3],colR,colG,colB);

	setlinestyle(SOLID_LINE,0,3);
	setcolor(3);
	setfillstyle(1, 3);



	int x1,y1,x2,y2;
	x1 = xn(x0-2); y1 = ym(y0+1);
	x2 = xn(x0+2); y2 = ym(y0-1);

	fillellipse((x1+x2)/2,(y1+y2)/2,abs(x2-x1)/2,abs(y2-y1)/2);


	x1 = xn(x0+1-1); y1 = ym(y0+0.5+1);
	x2 = xn(x0+1+1); y2 = ym(y0+0.5-1);


	fillellipse((x1+x2)/2,(y1+y2)/2,abs(x2-x1)/2,abs(y2-y1)/2);


}



//ࠥ 
Point TrajM(double t)
{
	Point P;
	P.x = -6.5;
	P.y = 0.1*t-3;
	return P;
}



// 
void Moon(double x0,double y0)
{



//	int col = (int)(255*(1-exp(-0.2*t)));


	setlinestyle(SOLID_LINE,0,3);
	setcolor(15);
	setfillstyle(1, 15);


	int x1,y1,x2,y2;
	x1 = xn(x0-1); y1 = ym(y0+0.8);
	x2 = xn(x0+1); y2 = ym(y0-0.8);

	fillellipse((x1+x2)/2,(y1+y2)/2,abs(x2-x1)/2,abs(y2-y1)/2);



}



//㥬 㭭 ஦
void LineMoon(double x, double t)
{


	double d1 = 1*(1-exp(-0.1*(t-20))), d2 = 4*(1-exp(-0.1*(t-20)));



	int Poly[8];

	Poly[0] = xn(x+d1); Poly[1] = ym(-0.1);
	Poly[2] = xn(x-d1); Poly[3] = ym(-0.1);
	Poly[4] = xn(-d2);  Poly[5] = ym(yBottom+0.1);
	Poly[6] = xn(d2);   Poly[7] = ym(yBottom+0.1);


	setlinestyle(SOLID_LINE,0,3);
	setcolor(15);
	setfillstyle(1, 15);

	fillpoly(4,Poly);

}



// 
void Star(double t)
{



  palettetype pal;
  getpalette(&pal);


	int colR = (int)(63*(1-exp(-0.001*t*t)));
	int colG = (int)(63*(1-exp(-0.001*t*t)));
	int colB = (int)(63*(1-exp(-0.001*t*t)));

  setrgbpalette(pal.colors[4],colR,colG,colB);

	setlinestyle(SOLID_LINE,0,3);
	setcolor(4);
	setfillstyle(1, 4);

	double x0, y0;
	int x1,y1,x2,y2;

	for(int k=0; k<50; k++)
	{
		x0 = xStar[k];  y0 = yStar[k];

		x1 = xn(x0); y1 = ym(y0);

		putpixel(x1,y1,4);
		putpixel(x1-1,y1,4);
		putpixel(x1+1,y1,4);
		putpixel(x1,y1-1,4);
		putpixel(x1,y1+1,4);


	}


}






//㥬 
void Sky( double t)
{

  palettetype pal;
  getpalette(&pal);

	int colR = (int)(50*exp(-0.004*t*t));
	int colG = (int)(63*exp(-0.01*t*t));
	int colB = (int)(63*exp(-0.01*t*t));

  setrgbpalette(pal.colors[2],colR,colG,colB);

	setlinestyle(SOLID_LINE,0,1);
	setcolor(2);
	setfillstyle(1, 2);


	bar(nLeft,mBottom,nRight,mTop);

}



//㥬 
void Sea(double t)
{


  palettetype pal;
  getpalette(&pal);

	int colR = 0;
	int colG = (int)(25/(1+0.1*t));
	int colB = (int)(58/(1+0.1*t));

  setrgbpalette(pal.colors[1],colR,colG,colB);



	setlinestyle(SOLID_LINE,0,1);
	setcolor(1);
	setfillstyle(1, 1);



	bar(nLeft,mBottom,nRight,(mTop+mBottom)/2);


	setcolor(LIGHTBLUE);



	moveto(nLeft,(mTop+mBottom)/2);
	lineto(nRight,(mTop+mBottom)/2);

}










//ᮧ  뢮
void CreatWindow()
{
	setfillstyle(SOLID_FILL, 1);
	bar(winLeft, winTop, winRight, winBottom);

	setcolor(11);

	outtextxy(winLeft+5, winTop+7, "Korneev V");

	setcolor(4);
	outtextxy(winLeft+105, winTop+7, "Move, drawing in video display page"
                            "  Sea and Ship");

	setcolor(15);
	rectangle(winLeft+3, winTop+17, winRight-3, winBottom-3);

	setfillstyle(SOLID_FILL, 0);
	bar(winLeft+5, winTop+19, winRight-5, winBottom-5);

	setviewport(winLeft+5, winTop+19, winRight-5, winBottom-5,1);

}


//㭪 ⠭ 믮 ணࠬ  ⨨
// ,  쭥 ⨨  
//ணࠬ த 믮
//室  ணࠬ - Esc
//         㭪 StopRunQuit()   ᯮ짮  横
//    do{
//       StopRunQuit();
//    }while(1);
//
void StopRunQuit()
{
  union inkey   // ⮬ ꥤ ࠭ ଠ  ⮩ 
  {                         //ch[0] -訩  (ASCII )
	 unsigned char ch[2];    //ch[1] -訩  ( ᪠஢ )
	 int i;                  //i -ꥤ    ᫮
  } c;


		if(kbhit())
		{
			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}

			while(!kbhit());

			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}
		}
}







void main()
{


	Move_OnCreate();


	CreatWindow();


	Sky(0);



//砫  ६  
   tB = 0; dtB = dtB0;

//砫  ६  ᮫
   tS = 0; dtS = dtS0;

//砫  ६  
   tC = 0; dtC = dtC0;

//砫  ६  
   tM = 0; dtM = dtM0;


//砫쭮  業 
	xB0 = TrajB(tB).x;
	yB0 = TrajB(tB).y;


//砫쭮  業 ᮫
	xS0 = TrajS(tS).x;
	yS0 = TrajS(tS).y;

//砫쭮  業 
	xC0 = TrajC(tC).x;
	yC0 = TrajC(tC).y;

//砫쭮  業 
	xM0 = TrajM(tM).x;
	yM0 = TrajM(tM).y;



	for(int n=0; n<8; n++)
		PtS[n] = PtS0[n];

	for( n=0; n<11; n++)
   	PtB[n] = PtB0[n];

	Moon(xM0,yM0);

	Sea(0);

	Sun(PtS,8,0,0,xS0,yS0,0,0.2,0.2);
	LineSun(xS0,0);

	Cloud(xC0,yC0,0);

	Boat(PtB,11,0,0,xB0,yB0,0,0.3,0.3);

	xB1 = xB0; yB1 = yB0;
	xS1 = xS0; yS1 = yS0;




	delay(1000);

	setactivepage(1);

	for(int f=1; ; f++)
	{

	setviewport(0, 0, getmaxx(), getmaxy(),1);
	clearviewport();

	CreatWindow();




		tS += dtS;
		dtS *= 0.9905;
		xS2 = TrajS(tS).x;
		yS2 = TrajS(tS).y;


	Sky(tS);
//㥬 䨣  窥 (x2, y2)
	Sun(PtS,8,xS1,yS1,xS2,yS2,fi,1.01,1.001);
	xS1 = xS2; yS1 = yS2;


		tM += dtM;
		dtM *= 0.997;
		xM = TrajM(tM).x;
		yM = TrajM(tM).y;

//㥬 䨣  窥 (x2, y2)

	if(yM>-1.0)
		Star(tM);


	Moon(xM, yM);

	Sea(tM);


	double xx;
	xx = xS2;
		if(yS2 < -0.0) xx = 0;

	if(yS2 > -1.0)
		LineSun(xx,tS);

	if(yM>-1.0)
		LineMoon(xM,tM);


		tC += dtC;
		xC = TrajC(tC).x;
		yC = TrajC(tC).y;

//㥬 䨣  窥 (x2, y2)
	Cloud(xC, yC, tC);



		tB += dtB;
		dtB *= 0.9913;
		xB2 = TrajB(tB).x;
		yB2 = TrajB(tB).y;

//㥬 䨣  窥 (x2, y2)
	TracB(tB, dtB);
	Boat(PtB,11,xB1,yB1,xB2,yB2,fi,kx,ky);
	xB1 = xB2; yB1 = yB2;





	StopRunQuit();
	delay(20);

		setvisualpage(f%2);
		setactivepage(1 - (f%2));


	}



}
