

#include <graphics.h>
#include <stdio.h>
#include <process.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <math.h>



void CreatWindow();





//ࠧ   ࠭ न ⭮⥫쭮 ࠭
int winLeft, winRight, winBottom, winTop;



//ࠧ  뢮  ஢ ⥬ न
double xLeft, xRight, yBottom, yTop;
//ࠧ  뢮  ᥫ   ணࠬ 
int    nLeft, nRight, mBottom, mTop;


//室  x  ᥫ n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//室  y  ᥫ m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}


//  ࠡ  栬 䨭 ८ࠧ
//ᯮ த न
class Matrix2D
{

public:
	double x[3][3];

	Matrix2D();                               // 筠

	void rotate(double fi);                      // 
	void displa(double kx, double ky);           // 殮
	void transl(double tx, double ty );          // ࠭樨

	//६ 
	friend Matrix2D operator * (const Matrix2D&, const Matrix2D&);

};

Matrix2D::Matrix2D()
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] =  0;
	x[1][0] =  0; x[1][1] =  1; x[1][2] =  0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


void Matrix2D::rotate(double fi)
{
	double cosfi = cos(fi), sinfi = sin(fi);
	x[0][0] = cosfi; x[0][1] = -sinfi; x[0][2] = 0;
	x[1][0] = sinfi; x[1][1] =  cosfi; x[1][2] = 0;
	x[2][0] =     0; x[2][1] =      0; x[2][2] = 1;
}

void Matrix2D::displa(double kx, double ky)
{
	x[0][0] = kx; x[0][1] =  0; x[0][2] = 0;
	x[1][0] =  0; x[1][1] = ky; x[1][2] = 0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] = 1;
}

void Matrix2D::transl(double tx, double ty )
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] = tx;
	x[1][0] =  0; x[1][1] =  1; x[1][2] = ty;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


Matrix2D operator * (const Matrix2D& a, const Matrix2D& b)
{
	Matrix2D c;
	double s;
	for(int i=0; i<3; i++)
		for(int j=0; j<3; j++)
		{
			s = 0;
			for(int n=0; n<3; n++)
				s += a.x[i][n]*b.x[n][j];
			c.x[i][j] = s;
		}
	return c;
}


//  ᠭ 祪 䨣
struct Point
{
	double x;
	double y;
};


//䨭 ८ࠧ न 窨 P  
// A
Point affine( Matrix2D A,  Point P)
{
	Point Pp;
		Pp.x = A.x[0][0]*P.x + A.x[0][1]*P.y + A.x[0][2]*1;
		Pp.y = A.x[1][0]*P.x + A.x[1][1]*P.y + A.x[1][2]*1;
	return Pp;
}







//न 設 ५ ⥪騥  砫
Point	PtA[7], PtA0[7];

//न 設 ᠬ ⥪騥  砫
Point	PtP[7], PtP0[7];


//"६"   ࠥਨ 業 ५
	double tA , dtA, dtA0;

//"६"   ࠥਨ 業 ᠬ
	double tP , dtP, dtP0;


// 㣮   樥 殮 ५
	double fiA, kxA, kyA;

// 㣮   樥 殮 ᠬ
	double fiP1, fiP2, kxP, kyP;

//ᮧ 6  䨭 ८ࠧ
	Matrix2D R, R1, T, D, A, T1, T2;

//砫  ⥪騥 窨 業 ५
	double xA0, yA0, xA2, yA2, xA1, yA1;

//砫  ⥪騥 窨 業 ᠬ
	double xP0, yP0, xP2, yP2, xP1, yP1;




//㭪 ࠡ뢠 ᮮ饭  WM_CREATE
void Move_OnCreate()
{


//樠 ᪮ ⥬
	int mode = 1, res, driver = 9;
  initgraph(&driver, &mode,"c:\\borlandc\\bgi");
  if((res = graphresult()) != grOk)
  {
	 printf("\nGraphics error: %s\n", grapherrormsg(res));
	 exit(1);
  }


//ࠧ   ࠭ न ⭮⥫쭮 ࠭
	winLeft = int(getmaxx()*0.1); winRight = int(getmaxx()*0.9);
	winBottom = int(getmaxy()*0.85); winTop = int(getmaxy()*0.1);

//ࠧ  뢮  ஢  ࠭ न
	xLeft = -10; xRight =  10; yBottom =  -6.52; yTop =  6.52;
	nLeft = 0; nRight  = winRight-winLeft-10;
	mTop  = 0; mBottom = winBottom-winTop-24;



//砫 न 設 ५
   PtA0[0].x =  1.0; PtA0[0].y =  0.0;
   PtA0[1].x =  2.0; PtA0[1].y =  0.0;
   PtA0[2].x =  0.0; PtA0[2].y =  2.0;
   PtA0[3].x = -2.0; PtA0[3].y =  0.0;
   PtA0[4].x = -1.0; PtA0[4].y =  0.0;
   PtA0[5].x = -1.0; PtA0[5].y = -2.0;
   PtA0[6].x =  1.0; PtA0[6].y = -2.0;

//砫 न 設 ᠬ
   PtP0[0].x =  6.0; PtP0[0].y =  0.0;
   PtP0[1].x =  4.0; PtP0[1].y =  2.0;
   PtP0[2].x = -3.0; PtP0[2].y =  0.0;
   PtP0[3].x = -4.0; PtP0[3].y =  2.0;
   PtP0[4].x = -6.0; PtP0[4].y =  2.0;
   PtP0[5].x = -6.0; PtP0[5].y = -1.0;
   PtP0[6].x =  4.0; PtP0[6].y = -2.0;


// 㣮   樥 殮 ५
	fiA = 3.14/70; kxA = 0.997; kyA = 0.997;

//樥 殮 ᠬ
	kxP = 0.997; kyP = 0.997;

//蠣  ६ ५
   dtA0 = 0.04;

//蠣  ६ ᠬ
   dtP0 = 0.11;


}


//ࠥ ५
Point TrajA(double t)
{
	Point P;
	P.x = t - 8;
	P.y = 4 - (t - 8)*(t - 8)/10;
	return P;
}




// ५  न⠬ 設 Pt
void Arrow( Point *Pt, int N, double x1,double y1,
           double x2,double y2,double fi,double kx,double ky)
{

//ᮧ  䨭 ८ࠧ
		T1.transl(-x1,-y1);
		R.rotate(fi);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*T1;

//ᮢ蠥 䨭 ८ࠧ 祪 䨣
		for(int n=0; n<N; n++)
			Pt[n] = affine(A,Pt[n]);




	int Poly[14];
	for(int i=0; i<14; i++)
		if((i % 2) == 0)
			Poly[i] = xn(Pt[i/2].x);
		else
			Poly[i] = ym(Pt[i/2].y);

	setlinestyle(SOLID_LINE,0,1);
	setcolor(LIGHTBLUE);
	setfillstyle(1, LIGHTRED);
	fillpoly(7,Poly);




}



//᫥  ५
void TracA( double te, double dt)
{
	double x, y, t;

	t = 0;
	x = TrajA(t).x;
	y = TrajA(t).y;


	setlinestyle(SOLID_LINE,0,3);
	setcolor(YELLOW);


	moveto(xn(x),ym(y));
	do{
		t += dt;
		x = TrajA(t).x;
		y = TrajA(t).y;
		lineto(xn(x),ym(y));
	}while(t < te);


}







//ࠥ ᠬ
Point TrajP(double t)
{
	Point P;
	P.x = -5 + 2*(t-2.5) - 4*sin(t-2.5);
	P.y = 1 - 4*cos(t-2.5);
	return P;
}



// ᠬ  न⠬ 設 Pt  窥 x2, y2
void Plain(Point *Pt, int N, double x1,double y1,
			  double x2,double y2,double fi1,double fi2,double kx,double ky)
{

//ᮧ  䨭 ८ࠧ
		T1.transl(-x1,-y1);
		R1.rotate(-fi1);
		R.rotate(fi2);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*R1*T1;

//ᮢ蠥 䨭 ८ࠧ 祪 䨣
		for(int n=0; n<N; n++)
			Pt[n] = affine(A,Pt[n]);



	int Poly[14];
	for(int i=0; i<14; i++)
		if((i % 2) == 0)
			Poly[i] = xn(Pt[i/2].x);
		else
			Poly[i] = ym(Pt[i/2].y);

	setlinestyle(SOLID_LINE,0,1);
	setcolor(BLUE);
	setfillstyle(1, LIGHTBLUE);
	fillpoly(7,Poly);


}

//᫥  ᠬ
void TracP(double te, double dt)
{
	double x, y, t;

	t = 0;
	x = TrajP(t).x;
	y = TrajP(t).y;


	setlinestyle(SOLID_LINE,0,1);
	setcolor(WHITE);

	moveto(xn(x),ym(y));
	do{
		t += dt;
		x = TrajP(t).x;
		y = TrajP(t).y;
		lineto(xn(x),ym(y));
	}while(t < te);

}









void Land()
{



	setfillstyle(SOLID_FILL, GREEN);
	setlinestyle(SOLID_LINE,0,1);
	setcolor(WHITE);


	fillellipse(xn(0),ym(0),70,110);

	//㥬 न 
	setlinestyle(SOLID_LINE,0,1);
	setcolor(CYAN);


	int nb, ne, mb, me;

	nb = xn(xLeft); mb = ym(0);
	moveto(nb, mb);
	ne = xn(xRight); me = ym(0);
	lineto(ne,me);

	nb = xn(0); mb = ym(yBottom);
	moveto(nb, mb);
	ne = xn(0); me = ym(yTop);
	lineto(ne,me);

}















//ᮧ  뢮
void CreatWindow()
{
	setfillstyle(SOLID_FILL, CYAN);
	bar(winLeft, winTop, winRight, winBottom);

	setcolor(LIGHTRED);

	outtextxy(winLeft+5, winTop+7, "Korneev V");

	setcolor(WHITE);
	outtextxy(winLeft+120, winTop+7, "Move, drawing in video display page");

	setcolor(WHITE);
	rectangle(winLeft+3, winTop+17, winRight-3, winBottom-3);

//	setfillstyle(SOLID_FILL, LIGHTGRAY);
	setfillstyle(SOLID_FILL, BLACK);
	bar(winLeft+5, winTop+19, winRight-5, winBottom-5);

	setviewport(winLeft+5, winTop+19, winRight-5, winBottom-5,1);

}


//㭪 ⠭ 믮 ணࠬ  ⨨
// ,  쭥 ⨨  
//ணࠬ த 믮
//室  ணࠬ - Esc
//         㭪 StopRunQuit()   ᯮ짮  横
//    do{
//       StopRunQuit();
//    }while(1);
//
void StopRunQuit()
{
  union inkey   // ⮬ ꥤ ࠭ ଠ  ⮩ 
  {                         //ch[0] -訩  (ASCII )
	 unsigned char ch[2];    //ch[1] -訩  ( ᪠஢ )
	 int i;                  //i -ꥤ    ᫮
  } c;


		if(kbhit())
		{
			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}

			while(!kbhit());

			c.i = bioskey(0);
			if(c.ch[0] == 27 && c.ch[1] == 1)
			{
				closegraph();
				exit(0);
			}
		}
}







void main()
{


	Move_OnCreate();


	CreatWindow();
	Land();


//砫  ६  ५
   tA = 0; dtA = dtA0;

//砫쭮  業 
	xA0 = TrajA(tA).x;
	yA0 = TrajA(tA).y;

	for(int n=0; n<7; n++)
   	PtA[n] = PtA0[n];

//㥬 ५  쭮 窥
	Arrow(PtA,7,0,0,xA0,yA0,0,0.75,0.75);

	xA1 = xA0; yA1 = yA0;

//砫  ६  ᠬ
	tP = 0; dtP = dtP0;

//砫쭮  業 ᠬ
	xP0 = TrajP(tA).x;
	yP0 = TrajP(tA).y;

	for( n=0; n<7; n++)
		PtP[n] = PtP0[n];

//㥬 ५  쭮 窥
	Plain(PtP,7,0,0,xP0,yP0,0,0,0.3,0.3);

	fiP1 = 0;
	xP1 = xP0; yP1 = yP0;




	delay(2000);

	setactivepage(1);

	for(int f=1; ; f++)
	{

	setviewport(0, 0, getmaxx(), getmaxy(),1);
	clearviewport();

	CreatWindow();


		tA += dtA;
		xA2 = TrajA(tA).x;
		if(xA2 >= xRight-1)
		{
			xA2 = xRight-1;
			tA -= dtA;
		}
		yA2 = TrajA(tA).y;



//㥬 䨣  窥 (x2, y2)
	Arrow(PtA,7,xA1,yA1,xA2,yA2,fiA,kxA,kyA);
	TracA( tA, dtA);

	xA1 = xA2; yA1 = yA2;

	Land();



		tP += dtP;
		dtP *= 0.99;
		xP2 = TrajP(tP).x;
		yP2 = TrajP(tP).y;

		fiP2 =atan2l(yP2-yP1,xP2-xP1);


//㥬 䨣  窥 (x2, y2)
	Plain(PtP,7,xP1,yP1,xP2,yP2,fiP1,fiP2,kxP,kyP);
	TracP(tP, dtP);

	xP1 = xP2; yP1 = yP2; fiP1 = fiP2;

	StopRunQuit();
	delay(30);

		setvisualpage(f%2);
		setactivepage(1 - (f%2));


	}



}
