

#include <graphics.h>
#include <stdio.h>


//⠥ ᪨ 䠩 bmp (16 梥⮢)
//⠥   BITMAPFILEHEADER, BITMAPINFOHEADER
//⠥ ⠢   16 梥⮢  ⥬ RGB

//塞  ⠭  㬮砭  ᪮ ⥪ BGI
//     䠩 bmp
//뢮 ࠦ  ࠭  ᥫ쭮
int ViewBMP(char* FileName)
{

// (14 ) ᮤন ଠ  ⨯, ࠧ   䠩,
// ᮤন ⭮-ᨬ ஢ ࠦ
typedef struct tagBITMAPFILEHEADER {
	 unsigned int    bfType;          //⨯ 䠩 - <BM>
	 unsigned long   bfSize;          //ࠧ 䠩 (B)
	 unsigned int    bfReserved1;
	 unsigned int    bfReserved2;
	 unsigned long   bfOffBits;      //ᬥ饭  砫 䠩 
} BITMAPFILEHEADER;                 //஢ ࠦ


// (40 ) ᮤন ଠ  ࠧ, 梥⮢ ଠ
//⭮-ᨬ ஢ ࠦ
typedef struct tagBITMAPINFOHEADER{
	 unsigned long   biSize;       //ࠧ  (B)
				 long   biWidth;      //ਭ ஢ ࠦ (pixel)
				 long   biHeight;     // ஢ ࠦ (pixel)
	 unsigned int    biPlanes;
	 unsigned int    biBitCount;
	 unsigned long   biCompression;
	 unsigned long   biSizeImage;
				 long   biXPelsPerMeter;
				 long   biYPelsPerMeter;
	 unsigned long   biClrUsed;
	 unsigned long   biClrImportant;
} BITMAPINFOHEADER;


// ⭮⥫ ⥭ᨢ red, green, blue 梥⮢
typedef struct tagRGBQUAD {
	 unsigned char	 rgbBlue;    //0 - 255
	 unsigned char	 rgbGreen;
	 unsigned char	 rgbRed;
	 unsigned char	 rgbReserved;
} RGBQUAD;


	BITMAPFILEHEADER Head14;
	BITMAPINFOHEADER Head40;
				RGBQUAD HeadRGB[16];  //  16 梥⮢

	FILE * fp;

	fp = fopen(FileName,"rb");
	if(fp==NULL)
		return 0;

	fread(&Head14, sizeof(Head14), 1, fp); //⠥  Head14
	fread(&Head40, sizeof(Head40), 1, fp); //⠥  Head40

	for(int i=0; i<16; i++)                //⠥ 
		fread(&HeadRGB[i], sizeof(RGBQUAD), 1, fp);


	long NPix, MPix;
	NPix = Head40.biWidth;
	MPix = Head40.biHeight;

	//᫮  ᮤঠ騥   窥 ஢ ࠦ
	unsigned long   NByt;
	NByt = (Head14.bfSize - Head14.bfOffBits)/MPix;


	//  ࠡ  ன
	struct palettetype pal;

	//७ᨬ ⥪     pal
	getpalette(&pal);


	//⠭   䠩 bmp
	// 梥  ஬ <m> ⠭    ॣ஢ DAC
	// 256 ॣ஢ DAC
	// ᯮ㥬  64 ॣ DAC,  ,
	// ॣ  ஬ pal.colors[m],    18 
	// ଠ  ᭮(6 ), (6 )  ᨭ(6 )
	// 梥  ஬ <m>
	for (int m=0; m<16; m++)
		setrgbpalette(pal.colors[m], 64*HeadRGB[m].rgbRed/256,
				64*HeadRGB[m].rgbGreen/256, 64*HeadRGB[m].rgbBlue/256);


	//⠭ 㪠⥫  䠩  砫 ஢ ࠦ
	fseek(fp,Head14.bfOffBits,SEEK_SET);


	unsigned char Holder, b1, b2, bb;
	int x = 0, y = 0;

	//뢠 ᥫ ஢ ࠦ  뢮  ࠭
	for(int b = MPix; b >=0; b--)
	{
		for(int a = 1; a <= NByt; a++)
		{
			if(2*a <= NPix)
			{
				fread(&Holder, 1, 1, fp);
				b1 = Holder>>4;
				bb = Holder<<4;
				b2 = bb>>4;
				putpixel(2*a-2+x,b+y,b1);
				putpixel(2*a-1+x,b+y,b2);
			}
			else
				if((2*a > NPix) && (2*a-1 == NPix))
				{
					fread(&Holder, 1, 1, fp);
					b1 = Holder>>4;
					putpixel(2*a-2+x,b+y,b1);
				}
				else
					fread(&Holder, 1, 1, fp);

		}
	}

	fclose(fp);
	return 1;
}


